﻿using System;
using System.ComponentModel;
using System.Linq;
using System.Reflection;

namespace DymWebForm.Common.Attributes
{
	internal static class Extensions
	{
		public static string GetDescriptionByAttribute(this ICustomAttributeProvider cap, bool inherit = true, string defaultResult = "")
	    {
	        return cap.GetCustomAttributes(inherit)
	                  .OfType<DescriptionAttribute>()
	                  .Select(p => p.Description)
	                  .FirstOrDefault() ?? defaultResult;
	    }
	
	    public static bool HasAttribute<T>(this ICustomAttributeProvider cap, bool inherit = true) where T : Attribute
	    {
	        return cap.IsDefined(typeof(T), inherit);
	    }
	}
}
