﻿using DymWebForm.Common.Attributes;
using DymWebForm.Common.Linq;
using System;
using System.Collections.Generic;
using System.Linq;

namespace DymWebForm.Common.BasicDataType
{
    internal static class Extensions
    {
        public static byte[] ToBytes(this int value)
        {
            return BitConverter.GetBytes(value);
        }

        public static string JoinString(this IEnumerable<string> source, string separator)
        {
            return string.Join(separator, source.ToArray());
        }

        public static string ToHexString(this byte[] buf)
        {
            return buf.SelectArray(p => p.ToString("X2"))
                      .JoinString("");
        }

        public static string Format(this string fmt, params object[] args)
        {
            return string.Format(fmt, args);
        }

        public static string ToDisplayString(this object value)
        {
            if (value is bool)
                return (bool)value ? "是" : "否";

            if (value is Enum)
            {
                return value.GetType().GetField(value.ToString()).GetDescriptionByAttribute() ?? value.ToString();
            }

            if (value == null)
                return null;

            return value.ToString();
        }
    }
}