﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace DymWebForm.Common.Web
{
    internal static class Extensions
    {
        public static T AddControl<T>(this Control control, T controlToAdd) where T : Control
        {
            control.Controls.Add(controlToAdd);
            return controlToAdd;
        }

        public static T AddCell<T>(this TableRow control, T controlToAdd) where T : TableCell
        {
            control.Cells.Add(controlToAdd);
            return controlToAdd;
        }

        public static void VisualText(this TableCell td, string text)
        {
            if (text == null)
            {
                td.ForeColor = Color.Red;
                td.Text = "NULL";
            }
            else if (string.IsNullOrEmpty(text))
            {
                td.ForeColor = Color.Orange;
                td.Text = "EMPTY";
            }
            else
            {
                td.Text = text;
            }
        }
    }
}
