﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace DymWebForm.Controls
{
    internal class DateTimeTextBox: TextBox
    {
        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            MaxLength = IsContainTime ? 19 : 10;
            Attributes.Add("size", MaxLength.ToString());

            ScriptManager.RegisterClientScriptResource(this, GetType(), GetType().Assembly.GetName().Name + ".Resources.Calendar.js");
        }

        protected override void Render(HtmlTextWriter writer)
        {
            base.Render(writer);
            var iconUrl = Page.ClientScript.GetWebResourceUrl(GetType(), GetType().Assembly.GetName().Name + ".Resources.Calendar.Icon.Norm.bmp");
            var iconUrl2 = Page.ClientScript.GetWebResourceUrl(GetType(), GetType().Assembly.GetName().Name + ".Resources.Calendar.Icon.Hove.bmp");

            writer.AddAttribute(HtmlTextWriterAttribute.Border, "0");
            writer.AddAttribute(HtmlTextWriterAttribute.Src, iconUrl);
            writer.AddAttribute(HtmlTextWriterAttribute.Onclick, string.Format("new Calendar(null, null, 0).show(document.getElementById('{0}'));", ClientID));
            writer.AddAttribute("onmouseover", string.Format("src='{0}';", iconUrl2));
            writer.AddAttribute("onmouseout", string.Format("src='{0}';", iconUrl));
            writer.RenderBeginTag(HtmlTextWriterTag.Img);
            writer.RenderEndTag();
        }

        public bool IsContainTime
        {
            get
            {
                if (ViewState[UniqueID + ":IsContainTime"] == null)
                {
                    return true; //the default value
                }

                return (bool)ViewState[UniqueID + ":IsContainTime"];
            }
            set
            {
                ViewState[UniqueID + ":IsContainTime"] = value;
            }
        }
    }
}